@echo off

rem %1 = fully qualified path of drive/directory of certutil and the netscape dll's
rem %2 = fully qualified name of password file 
rem %3 = fully qualified path of server cert dir
rem %4 = hostname
rem %5 = domain name

@%~d1
@cd %1

rem create noise file
date /t > %windir%\ggs_date1.txt
time /t > %windir%\ggs_time1.txt
set > %windir%\ggs_set.txt
date /t > %windir%\ggs_date2.txt
time /t > %windir%\ggs_time2.txt
copy /a %windir%\ggs_date1.txt + /a %windir%\ggs_time1.txt + /a %windir%\ggs_set.txt + /a %windir%\ggs_date2.txt + /a %windir%\ggs_time2.txt /v %windir%\ggs_noise.txt /a
del %windir%\ggs_date1.txt
del %windir%\ggs_time1.txt
del %windir%\ggs_set.txt
del %windir%\ggs_date2.txt
del %windir%\ggs_time2.txt

@echo Generating CertDB files...
@if exist %2 certutil -N -d %3 -f %2 else goto _err_invalid_passfile
if %errorlevel% NEQ 0 goto _err_ca_certdb_error

@echo Generating CA certificate...
@certutil -S -n SampleRootCA -x -t "CTu,CTu,CTu" -s "CN=CA %4.%5 CA, O=%5" -m 25000 -o %3/SampleRootCA.crt -d %3 -f %2 -z %windir%\ggs_noise.txt
if %errorlevel% NEQ 0 goto _err_ca_cert_error

@echo Generating Server certificate...
@certutil -S -n SampleSSLServerCert -c SampleRootCA -t "u,u,u" -s "CN=%4.%5, O=%4" -m 25001 -o %3/SampleSSLServer.crt -d %3 -f %2 -z %windir%\ggs_noise.txt
if %errorlevel% NEQ 0 goto _err_server_cert

@echo Testing the certificates...
@certutil -V -u V -n SampleSSLServerCert -d %3
if %errorlevel% NEQ 0 goto _err_test_failed

goto cleanup


:_err_invalid_passfile
@echo Password file was invalid.
goto _err_gen_error

:_err_ca_certdb_error
@echo The certificate database was not created.
goto _err_gen_error

:_err_ca_cert_error
@echo The certificate of authority was not created.
goto _err_gen_error

:_err_server_cert
@echo The server certificate was not created.
goto _err_gen_error

:_err_test_failed
@echo The certificates failed system testing
goto _err_gen_error

:_err_gen_error
@echo .
@echo There were errors trying create the default SSL Certificates.
@echo The product will not work correctly in SSL Mode.
@echo Please contact SourceGear technical support for assistance.
pause
goto cleanup

:cleanup
@echo Cleaning up temp files...
@del /f %2
@del /f %windir%\ggs_noise.txt
@del /f tempcert*.*
